/*===========================================================================
SOLAR :: ..\common\ex1parm.c

Original Author: Kevin Houle <kjhoule@iowegia.des-moines.ia.us>
This software module has been placed into the public domain.
===========================================================================*/

/* Header Files */
#include <string.h>
#include <dir.h>

/*
 * Function: char *extract_parm(char string[128], char delimiter)
 * Purpose : Extracts one word found after a delimiter in a string.
 * Return  : Returns the word found.
*/

char *extract_parm(char string[128], char delimiter)
{
	int  idx  = 0;
	int  idx2 = 0;
	char path[MAXPATH];

  while (string[idx++] != delimiter);
  while ((string[idx] == ' ') || (string[idx] == '\t')) idx++;
  while ((string[idx] != ' ') && (string[idx] != '\0') && \
         (string[idx] != '\n') && (string[idx] != '\t'))
	{
		if (string[idx] == '/')
		{
			path[idx2++] = '\\';
		}
		else
		{
			path[idx2++] = string[idx];
		}
		idx++;
	}

  /* Allow trailing backslashes to work if present by stomping it. */
  if (path[idx2 - 1] == '\\')
    path[idx2 - 1] = '\0';
  else
    path[idx2] = '\0';

	return path;
}
