#define MAILBOX_DESC "Electronic Mail"
#define MAILBOX_NAME "MAILBOX.F"    /* Complies with v1.65 of Waffle.  */
#define AREAS_NAME       "AREAS"    /* Complies with v1.2 of SOUP      */
#define BATCH_EXT          "MSG"    /* Complies with v1.2 of SOUP      */
#define ERROR_FILE      "ERRORS"    /* Complies with v1.2 of SOUP      */

enum SOUP_Types { u, M, m, n, C, c, i, b, B };  /* Possible types */
enum Exit_Codes { x_success, x_usage, x_fatal };   /* Exit codes */

/* Global Data */

/* External Data */
extern char temp_path[MAXPATH];
extern char user_path[MAXPATH];
extern char config_path[MAXPATH];
extern int  mail_type;
extern int  mail_index;
extern int  delete_mail;
extern char batch_prefix[10];
extern char waffle_version[5];
extern int  use_fossil;
extern int  port;
extern int  verbose;
extern char _slrerr[80];
extern char logbuf[128];                    /* From logit.c  */

/* External Functions */
extern int  load_static(char username[10]); /* From config.c */
extern int  load_config();                  /* From config.c */
extern int  user_defaults();                /* From config.c */

/* Common Functions */
extern int  getopt(int argc, char *argv[], const char *optionS);
extern int  set_directory(char *path);
extern int  get_batch_prefix();
extern int  logit(const char *facility);
extern int  mail_update(char *username);
extern int  read_doors();

/* Local Data */
char buf[1024];

/* Local Functions */
void usage();
