/*===========================================================================
SOLAR slrreply v0.95.3 :: Module ..\slrreply\config.h
Original author : Kevin Houle <kjhoule@iowegia.des-moines.ia.us>

This source code has been placed into the public domain.
===========================================================================*/

/* Common Includes */

#include "..\common\yesno.h"

/* Defines */

#define WAFFLE_SYSTEM        "_SYSTEM"  /* Waffle's _system file name */

/* Global Data */

char temp_path[MAXPATH];        /* Full path to temporary directory.  */
char user_path[MAXPATH];        /* Full path to user directory.       */
char config_path[MAXPATH];      /* Full path to configuration file    */
char log_path[MAXPATH];         /* Full path to log file.             */
char static_path[MAXPATH];      /* Full path to Waffle's static file  */
char waffle_path[MAXPATH];      /* Full path to Waffle root dir       */
char system_path[MAXPATH];      /* Full path to ~/system directory    */
char extern_path[MAXPATH];      /* Full path to ~/extern directory    */
char lost_path[MAXPATH];        /* Full path to lost+found directory  */
char solar_path[MAXPATH];       /* Full path to main Solar directory  */
char swap_path[MAXPATH];        /* Path to swap directory             */
char news_program[80];          /* Path to News Program               */
char mail_program[80];          /* Path to Mail Program               */
int  diskswap;                  /* Swap slrreply to disk ?            */
int  use_fossil;                /* If to use FOSSIL                   */
int  port;                      /* COM port for FOSSIL, 0 = COM1:     */
long _maxmailsize;              /* Maximum number of bytes for mail   */
long _maxnewssize;              /* Maximum number of bytes for news   */
long spam_max;                  /* Maximim newsgroups per news msg.   */
char backbone[40];              /* Backbone for moderated posts       */
char domain_name[40];           /* Host system registered domain      */
char uucp_name[10];             /* Host system registered UUCP name   */
char organization[128];         /* Host system organization           */
char tz[15];                    /* Timezone from Waffle's static      */
char _slrerr[80];               /* Error handling message buffer      */
int  verbose;                   /* Verbose mode                       */

/* External Functions */

extern char *extract_parm(char string[128], char delimiter);

/* Local functions */

char *full_line(char line[128]);
