/*===========================================================================
SOLAR v0.95.3 slrreply :: Module ..\slrreply\slrreply.c
Original Author : Kevin Houle <kjhoule@iowegia.des-moines.ia.us>

This source code has been placed into the public domain.
===========================================================================*/

/* Includes */

#include "..\common\version.h"
#include "..\common\yesno.h"

/* Local Definitions */

#define NEWS_PROGRAM       "RNEWS.EXE"   /* Assumes program is on PATH */
#define MAIL_PROGRAM       "RMAIL.EXE"   /* Assumes porgram is on PATH */

enum Exit_Codes { x_success, x_usage, x_fatal };  /* Exit codes */

/* Global Data */

extern char temp_path[MAXPATH];      /* From config.c */
extern char user_path[MAXPATH];      /* From config.c */
extern char config_path[MAXPATH];    /* From config.c */
extern char log_path[MAXPATH];       /* From config.c */
extern char static_path[MAXPATH];    /* From config.c */
extern char waffle_path[MAXPATH];    /* From config.c */
extern char system_path[MAXPATH];    /* From config.c */
extern char extern_path[MAXPATH];    /* From config.c */
extern char lost_path[MAXPATH];      /* From config.c */
extern char solar_path[MAXPATH];     /* From config.c */
extern char swap_path[MAXPATH];      /* From config.c */
extern char news_program[80];        /* From config.c */
extern char mail_program[80];        /* From config.c */
extern int  diskswap;                /* From config.c */
extern int  use_fossil;              /* From config.c */
extern int  port;                    /* From config.c */
extern long _maxmailsize;            /* From config.c */
extern long _maxnewssize;            /* From config.c */
extern char backbone[40];            /* From config.c */
extern char domain_name[40];         /* From config.c */
extern char uucp_name[10];           /* From config.c */
extern char organization[128];       /* From config.c */
extern char tz[15];                  /* From config.c */
extern char _slrerr[80];             /* From config.c */
extern int  verbose;                 /* From config.c */
extern char logbuf[128];             /* From logit.c  */

/* External Functions */

extern int getopt(int argc, char *argv[], const char *optionS);
extern int read_doors();                          /* From doors.c   */
extern int load_static();
extern int load_config();
extern int set_directory(char *path);            
extern int logit(const char *facility);           /* From logit.c   */  
extern int decompress_packet();
extern int process_packet();

/* Global data */

char username[10];
char real_name[128];

/* Local Functions */

void usage();
