/*===========================================================================
SOLAR v0.95.3 slrxfer :: Module ..\slrxfer\config.h
Original Author: Kevin Houle <kjhoule@iowegia.des-moines.ia.us>

This software module has been placed in the public domain.
===========================================================================*/

/* Common Includes */

#include "..\common\yesno.h"
#include "..\common\soup.h"

/* Static Data Definitions */

#define OPTIONS_NAME    "OPTIONS.SLR"
#define ONCE                        2

/* Global Data Storage */

char   temp_path[MAXPATH];        /* Path to temporary directory      */
char   user_path[MAXPATH];        /* Path to user's directory         */
char   config_path[MAXPATH];      /* Full path to Solar config file   */
char   log_path[MAXPATH];         /* Full path to Solar log file      */
char   static_path[MAXPATH];      /* Full path to Waffle's static     */
char   waffle_path[MAXPATH];      /* Full path to Waffle root dir     */
char   swap_path[MAXPATH];        /* Path to swap directory           */
int    diskswap;                  /* Swap slrxfer to disk ?           */
int    use_fossil;                /* Use a FOSSIL driver              */
int    port;                      /* COM port for FOSSIL, 0 = COM1:   */
int    verbose;                   /* Verbose mode toggle              */
char   _slrerr[80];               /* Global error message buffer      */

char   uucpname[15];              /* Host system's UUCP name          */
char   protocol[10];              /* Transfer protocol type           */

/* External Global Functions */

extern char *extract_parm(char string[128], char delimiter);
extern int  convert_to_number(char *argument);
extern int get_protocol_type(char buf[128]);
